/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package oracle.iam.assets.eventhandlers.extuserinfo.utils;


import java.util.Hashtable;

import oracle.iam.assets.eventhandlers.exception.ContractorIDPPEventHandlerException;
import oracle.iam.assets.eventhandlers.extuserinfo.utils.common.ServiceTypeEnum;

/**
 *This abstract class defines static methods to get/set the service type and to
 *    get an instance of that service type.This class also declares abstract
 *    methods to connect to the service and to get the data.
 */
public abstract class AbstractServiceUtilities {
    private static ServiceTypeEnum serviceType;

    /**
     * This method is used to get the type of service.
     * @return this method returns the type of service.
     */
    public static ServiceTypeEnum getServiceType() {
        return serviceType;
    }

    /**
     * This method is used to set the service type.
     * @param serviceType defines which service needs to be set.
     */
    public static void setServiceType(ServiceTypeEnum serviceType) {
        AbstractServiceUtilities.serviceType = serviceType;
    }

    /**
     * This is used to instantiate an object depending upon the serviceType.
     * @return This method returns an object of type AbstractServiceUtilities
     */
    public static AbstractServiceUtilities getInstance() {
        AbstractServiceUtilities instance = null;

        switch (serviceType) {
        case DBSERVICE:
            instance = new DBServiceUtils();
            break;
        }

        return instance;
    }

    /**
     * This method is used to establish the connection with the service.
     * @param connParams  : This is a HashTable which contains all the connection parameters.
     */
    public abstract void establishConnection(Hashtable<String, String> connParams) throws ContractorIDPPEventHandlerException;

    /**
     * This method is used to get the desired data from the service.
     * @param inputParams : This is a HashTable which is used to get the values of
     *    the parameters required for forming the statement.
     * @return This function returns the value of the required data field from
     *    the requested service.
     */
    public abstract String getData(Hashtable<String, String> inputParams,
                                   String userID) throws ContractorIDPPEventHandlerException;
}
